#include <iostream>
#include <math.h>
#include <string.h>
#include <algorithm>  
using namespace std;
 
int main(int argc, char** argv) 
    {
    int t;
    long long nzd;
    long long n,m;
    long long a1,a2,a3;
    long long b;
    cin>>t;
    for(int i=0;i<t;i++)
    {
        int f=1;
        cin>>n>>m;
        cin>>a1>>a2;
        nzd=__gcd(a1,a2);
        for(int i=2;i<n;i++)
        {
            cin>>a3;
            nzd=__gcd(nzd,a3);
        }
        for(int i=0;i<m && f==1;i++)
        {
            cin>>b;
            if(abs(a1-b)%nzd==0)
            {
                f=0;    
            }
        }
        cout<<f<<endl;
    }
    return 0;
}